<template>
	<section class="FieldsViewControls grey lighten-4" aria-label="filters">
		<div class="FieldsViewControl-searchInputContainer">
			<fields-view-search-input />
			<span v-if="isLoaded" class="FieldsViewControls-resultsDisplay v-messages theme--light">
				{{ numberOfResults }} results
			</span>
		</div>

		<div class="FieldsViewControls-filters d-flex">
			<v-menu offset-y :close-on-content-click="false" v-model="showGroupFilter">
				<template v-slot:activator="{ on, attrs }">
					<v-btn class="FieldsViewControls-menuButton" v-bind="attrs" v-on="on" outlined> Group </v-btn>
				</template>
				<fields-view-group-filter
					class="FieldsViewControls-control"
					@ok="showGroupFilter = false"
					:useDesktopLayout="true"
				/>
			</v-menu>

			<v-menu offset-y :close-on-content-click="false" v-model="showRecentActivityFilter">
				<template v-slot:activator="{ on, attrs }">
					<v-btn class="FieldsViewControls-menuButton" v-bind="attrs" v-on="on" outlined> Recent Activity </v-btn>
				</template>
				<fields-view-recent-activity-filter
					class="FieldsViewControls-control"
					@ok="showRecentActivityFilter = false"
					:useDesktopLayout="true"
				/>
			</v-menu>

			<v-menu offset-y :close-on-content-click="false" v-model="showStatusFilter">
				<template v-slot:activator="{ on, attrs }">
					<v-btn class="FieldsViewControls-menuButton" v-bind="attrs" v-on="on" outlined>Status</v-btn>
				</template>
				<fields-view-status-filter
					class="FieldsViewControls-control"
					@ok="showStatusFilter = false"
					:useDesktopLayout="true"
				/>
			</v-menu>

			<button class="FieldsViewControls-clearAll primary--text" @click="clearAllFilters">Clear all filters</button>

			<v-menu offset-y v-model="showExportCSV">
				<template v-slot:activator="{ on, attrs }">
					<v-btn
						class="FieldsViewControls-menuButton FieldsViewControls-tripleDot ml-auto"
						v-bind="attrs"
						v-on="on"
						icon
						tile
						:width="15"
						color="#000000de"
					>
						<v-icon>mdi-dots-vertical</v-icon>
					</v-btn>
				</template>
				<v-list class="pa-0">
					<fields-view-export-csv class="FieldsViewControls-control" @ok="showExportCSV = false" />

					<add-stratification-dialog v-slot="{ attrs, on }" @open="showExportCSV = false">
						<v-list-item v-bind="attrs" v-on="on">
							<v-list-item-title>Add Stratification</v-list-item-title>
						</v-list-item>
					</add-stratification-dialog>
				</v-list>
			</v-menu>
		</div>
	</section>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import AddStratificationDialog from '@/components/dialog/AddStratificationDialog.vue';
import { useAllResources } from '@/store/modules/resources';
import FieldsViewExportCsv from './FieldsViewExportCsv.vue';
import FieldsViewGroupFilter from './FieldsViewGroupFilter.vue';
import FieldsViewRecentActivityFilter from './FieldsViewRecentActivityFilter.vue';
import FieldsViewSearchInput from './FieldsViewSearchInput.vue';
import FieldsViewStatusFilter from './FieldsViewStatusFilter.vue';

export default defineComponent({
	components: {
		FieldsViewSearchInput,
		FieldsViewGroupFilter,
		FieldsViewRecentActivityFilter,
		FieldsViewStatusFilter,
		FieldsViewExportCsv,
		AddStratificationDialog,
	},
	setup(_, { root }) {
		const showGroupFilter = ref(false);
		const showRecentActivityFilter = ref(false);
		const showStatusFilter = ref(false);
		const showExportCSV = ref(false);
		const numberOfResults = computed(() => root.$store.getters['fieldsView/getFieldRowsLength']);
		const { isLoaded } = useAllResources(root.$store);

		return {
			showGroupFilter,
			showRecentActivityFilter,
			showStatusFilter,
			showExportCSV,
			numberOfResults,
			isLoaded,
			clearAllFilters: () => {
				root.$store.dispatch('fieldsView/clearAllFilters');
			},
		};
	},
});
</script>

<style lang="scss">
.FieldsViewControls {
	display: flex;
	flex-wrap: wrap;
	margin: 0 16px;

	.FieldsViewControl-searchInputContainer {
		position: relative;
		flex: 1 1 0%;
		max-width: 300px;
		margin-right: 16px;
		min-width: 270px;

		.FieldsViewControls-resultsDisplay {
			position: absolute;
			right: 0;
			bottom: 7px;
		}
	}

	& .FieldsViewControls-filters {
		height: 40px;
		margin-bottom: 12px;
		flex-grow: 1;

		& > *:not(:last-child) {
			margin-right: 16px;
		}

		& > .v-btn {
			height: 100% !important; /* match search input height */
		}

		.FieldsViewControls-menuButton {
			background: #fff;
			&.FieldsViewControls-tripleDot {
				background: inherit;
			}

			&.ml-auto {
				padding: 0;
				width: 40px;
			}
		}
	}
}

.FieldsViewControls-control {
	min-width: 150px;
}

@media (max-width: 848px) {
	.FieldsViewControls .FieldsViewControl-searchInputContainer {
		min-width: 100%;
		margin-right: 0;
	}
}
</style>
